/***************************************************************************
 *   Copyright (C) 2007 by Francesc Burrull i Mestres.                     *
 *   francesc.burrull@upct.es                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _W2LAN_CORE_H_
#define _W2LAN_CORE_H_

#ifndef _W2LAN_H_
#include "w2lan.h"
#endif

#ifndef _W2LAN_LISTS_H_
#include "w2lan_lists.h"
#endif

// ether_aton
#include <netinet/ether.h>

// assert
#include <assert.h>

//void announce_received( char *payload, u_int8_t *fromMAC, unsigned char *useless );
void announce_received( unsigned char *extra , const struct pcap_pkthdr *pkthdr , const unsigned char *packet );

void request_received( unsigned char *extra , const struct pcap_pkthdr *pkthdr , const unsigned char *packet );

void data_received( unsigned char *extra , const struct pcap_pkthdr *pkthdr , const unsigned char *packet );

void timer_expired(pcap_t *pd);

void generate_announce( unsigned char *extra , const struct pcap_pkthdr *pkthdr , const unsigned char *packet );

#endif
